package federatedtemplistener;

import federatedtemplistener.events.AverageTemperatureEvent;
import org.apache.flink.api.common.functions.AggregateFunction;
import org.apache.flink.api.java.tuple.Tuple3;

/**
 * @author ebruno
 */
public class Aggregation implements 
        AggregateFunction<  AverageTemperatureEvent, 
                            AverageAccumulator, 
                            Tuple3<Integer, Long, Double>> {
    
     public AverageAccumulator createAccumulator() {
         return new AverageAccumulator();
     }

     public AverageAccumulator merge(AverageAccumulator a, AverageAccumulator b) {
         a.count += b.count;
         a.sum += b.sum;
         return a;
     }

     public AverageAccumulator add(AverageTemperatureEvent evt, AverageAccumulator acc) {
         acc.key = evt.getDeviceId();
         acc.sum += evt.getTemperature();
         acc.count++;
         return acc;
     }

     public Tuple3<Integer, Long, Double>  getResult(AverageAccumulator acc) {
         return new Tuple3<>(acc.key, acc.count, acc.sum );
     }
}
