package federatedtemplistener;

import federatedtemplistener.events.AggregateTemperatureEvent;
import federatedtemplistener.events.GlobalAverageTemperatureEvent;
import org.apache.flink.api.common.functions.AggregateFunction;

/**
 * @author ebruno
 */
public class GlobalAverage implements 
        AggregateFunction<  AggregateTemperatureEvent, 
                            AverageAccumulator, 
                            GlobalAverageTemperatureEvent> {
    
     public AverageAccumulator createAccumulator() {
         return new AverageAccumulator();
     }

     public AverageAccumulator merge(AverageAccumulator a, AverageAccumulator b) {
         a.count += b.count;
         a.sum += b.sum;
         return a;
     }

     public AverageAccumulator add(AggregateTemperatureEvent evt, AverageAccumulator acc) {
         acc.key = evt.getDeviceId();
         acc.sum += evt.getTemperatureSum();
         acc.count += evt.getCount();
         return acc;
     }

     public GlobalAverageTemperatureEvent getResult(AverageAccumulator acc) {
         //return ((double)acc.sum / (double)acc.count);
         //System.out.println("GlobalAverageTemperatureEvent(device="+acc.key+", sum="+acc.sum+", count="+acc.count+")");
         return new GlobalAverageTemperatureEvent((double)acc.sum / (double)acc.count);
     }
 }
