package federatedtemplistener.events;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * @author Eric_Bruno
 */
public class AverageTemperatureEvent extends DeviceEvent {
    double temperature;
    static Logger logger;
    
    public AverageTemperatureEvent(int deviceId, String json) {
        this.deviceId = deviceId;
        this.temperature = temperature;
        logger = LoggerFactory.getLogger(AverageTemperatureEvent.class);
        //logger.info("TemperatureEvent Constructor. DeviceId="+deviceId+", Temp="+temperature);
        
        if ( json != null && json.length() > 0 ) {
            String DEVICE_ID_KEy = "\"deviceId\":";
            int start = json.indexOf(DEVICE_ID_KEy) + DEVICE_ID_KEy.length();
            start = json.indexOf("\"",start)+1;
            int end = json.indexOf("\"", start);
            String sDeviceId = json.substring(start, end);

            String AVG_TEMP_KEY = "\"averageTemperature\":";
            start = json.indexOf(AVG_TEMP_KEY) + AVG_TEMP_KEY.length();
            start = json.indexOf("\"",start)+1;
            end = json.indexOf("\"", start);
            String sAvgTemp = json.substring(start, end);
            
            temperature = new Double(sAvgTemp.trim()).doubleValue();
        }
    }

    public AverageTemperatureEvent() {
        this(-1, null);
    }

    public double getTemperature() {
        return temperature;
    }

    public void setTemperature(double temperature) {
        this.temperature = temperature;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof AverageTemperatureEvent) {
            AverageTemperatureEvent other = (AverageTemperatureEvent) obj;
            return super.equals(other) && temperature == other.temperature;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return 41 * super.hashCode() + Double.hashCode(temperature);
    }
    
    @Override
    public String toString() {
        return "AverageTemperatureEvent(" + getDeviceId() + ", " + temperature + ")";
    }    
}
