package federatedtemplistener.events;

/**
 * @author ebruno
 */
public class GlobalAverageTemperatureEvent {
    double averageTemp;

    public GlobalAverageTemperatureEvent(double averageTemp) {
        this.averageTemp = averageTemp;
    }

    public GlobalAverageTemperatureEvent() {
        this(-1);
    }
    
    public double getAverageTemp() {
        return averageTemp;
    }

    public void setAverageTemp(double averageTemp) {
        this.averageTemp = averageTemp;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof GlobalAverageTemperatureEvent) {
            GlobalAverageTemperatureEvent other = (GlobalAverageTemperatureEvent) obj;
            return averageTemp == other.averageTemp;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return 41 * super.hashCode() + Double.hashCode(averageTemp);
    }
    
    @Override
    public String toString() {
        return "GlobalAverageTemperatureEvent( Data center average temperature: " + getAverageTemp() + ")";
    }    
}
