/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package flinktemplistener;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import org.apache.flink.api.java.tuple.Tuple3;
import org.apache.flink.streaming.util.serialization.SerializationSchema;

/**
 *
 * @author ebruno
 */
public class AggregateSerializer 
        implements SerializationSchema<Tuple3<Integer, Long, Double>> {

    @Override
    public byte[] serialize(Tuple3<Integer, Long, Double> object) {
        return dataSerializer(object);
    }
    
    public byte[] objectSerializer(Tuple3<Integer, Long, Double> t) {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        ObjectOutput out = null;
        try {
            out = new ObjectOutputStream(bos);
            out.writeObject(t);
            out.flush();
            byte[] bytes = bos.toByteArray();
            System.out.print("Bytes: " );
            for ( byte b: bytes) {
                System.out.print(""+b);
            }
            System.out.println();
            return bytes;
        } 
        catch (Exception e) {
            e.printStackTrace();
        } 
        finally {
            try {
                bos.close();
            } catch (IOException ex) { }
        }

        return null;
    }
    
    // DataOutputStream-based serialization is faster than Object serialization
    //
    public byte[] dataSerializer(Tuple3<Integer, Long, Double> object) {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        try {
            DataOutputStream out = new DataOutputStream(bos);
            out.writeInt(object.f0);
            out.writeLong(object.f1);
            out.writeDouble(object.f2);
            out.flush();
            byte[] bytes = bos.toByteArray();
            System.out.print("Bytes: " );
            for ( byte b: bytes) {
                System.out.print(""+b);
            }
            System.out.println();
            return bytes;
        }
        catch (Exception e) {
            e.printStackTrace();
        } 
        finally {
            try {
                bos.close();
            } catch (IOException ex) { }
        }

        return null;
    }

}
