package flinktemplistener;

import flinktemplistener.events.TemperatureEvent;
import org.apache.flink.api.common.functions.AggregateFunction;
import org.apache.flink.api.java.tuple.Tuple2;

/**
 * @author ebruno
 */
public class Average implements 
        AggregateFunction<  TemperatureEvent, 
                            AverageAccumulator, 
                            Tuple2<Integer, Double>> {
    
     public AverageAccumulator createAccumulator() {
         return new AverageAccumulator();
     }

     public AverageAccumulator merge(AverageAccumulator a, AverageAccumulator b) {
         a.count += b.count;
         a.sum += b.sum;
         return a;
     }

     public AverageAccumulator add(TemperatureEvent evt, AverageAccumulator acc) {
         acc.key = evt.getDeviceId();
         acc.sum += evt.getTemperature();
         acc.count++;
         return acc;
     }

     public Tuple2<Integer, Double>  getResult(AverageAccumulator acc) {
         return new Tuple2<>(acc.key, acc.sum / (double) acc.count);
         //return new Tuple2<>((int)acc.count, acc.sum / (double) acc.count);
     }
 }
