package flinktemplistener.events;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author ebruno
 */
public class TemperatureAverage extends DeviceEvent {
    double averageTemperature;
    static Logger logger;
    
    public TemperatureAverage(int deviceId, double averageTemperature) {
        this.deviceId = deviceId;
        this.averageTemperature = averageTemperature;
        
        logger = LoggerFactory.getLogger(TemperatureAverage.class);
        //logger.info("TemperatureEvent Constructor. DeviceId="+deviceId+", Temp="+temperature);
    }

    public TemperatureAverage() {
        this(-1, -1);
    }

    public double getAverageTemperature() {
        return averageTemperature;
    }

    public void setAverageTemperature(double averageTemperature) {
        this.averageTemperature = averageTemperature;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TemperatureAverage) {
            TemperatureAverage other = (TemperatureAverage) obj;
            return super.equals(other) && averageTemperature == other.averageTemperature;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return 41 * super.hashCode() + Double.hashCode(averageTemperature);
    }
    
    @Override
    public String toString() {
        return "TemperatureAverage(" + getDeviceId() + ", avg temp=" + getAverageTemperature() + ")";
    }    
}
