package flinktemplistener.events;

import flinktemplistener.FlinkAverageTemperature;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * @author Eric_Bruno
 */
public class TemperatureEvent extends DeviceEvent {
    double temperature;
    static Logger logger;
    
    public TemperatureEvent(int deviceId, double temperature) {
        this.deviceId = deviceId;
        this.temperature = temperature;
        
        logger = LoggerFactory.getLogger(TemperatureEvent.class);
        //logger.info("TemperatureEvent Constructor. DeviceId="+deviceId+", Temp="+temperature);
    }

    public TemperatureEvent() {
        this(-1, -1);
    }

    public double getTemperature() {
        return temperature;
    }

    public void setTemperature(double temperature) {
        this.temperature = temperature;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TemperatureEvent) {
            TemperatureEvent other = (TemperatureEvent) obj;
            return super.equals(other) && temperature == other.temperature;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return 41 * super.hashCode() + Double.hashCode(temperature);
    }
    
    @Override
    public String toString() {
        return "TemperatureEvent(" + getDeviceId() + ", " + temperature + ")";
    }    
}
