package com.ebruno.natsiopubsubconnector;


import io.nats.client.Message;
import org.apache.flink.api.common.serialization.DeserializationSchema;
import org.apache.flink.api.common.serialization.SerializationSchema;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.api.common.typeinfo.Types;

/**
 *
 * @author ebruno
 */
public class NATSMessageSchema<T> 
        implements  DeserializationSchema<T>,
                    SerializationSchema<T> {

    @Override
    public T deserialize(byte[] bytes) {
        return (T)new String(bytes);
    }

    @Override
    public byte[] serialize(T myMessage) {
        return myMessage.toString().getBytes();
    }

    @Override
    public TypeInformation<T> getProducedType() {
        return (TypeInformation<T>)Types.STRING;
    }

    // Method to decide whether the element signals the end of the stream.
    // If true is returned the element won't be emitted.
    @Override
    public boolean isEndOfStream(T myMessage) {
        return false;
    }   
}
