package com.ebruno.natsiopubsubconnector;

import io.nats.client.Message;
import org.apache.flink.api.common.serialization.DeserializationSchema;
import org.apache.flink.api.common.typeinfo.TypeInformation;

/**
 *
 * @author ebruno
 */
public class PubSubDeserializationSchemaImpl<T> implements PubSubDeserializationSchema {
    private final DeserializationSchema<T> deserializationSchema;

    public PubSubDeserializationSchemaImpl(DeserializationSchema<T> deserializationSchema) {
		this.deserializationSchema = deserializationSchema;
	}

    @Override
    public boolean isEndOfStream(Object nextElement) {
        return false;
    }

    @Override
    public T deserialize(Message message) throws Exception {
        return deserializationSchema.deserialize( message.getData() );
    }

    @Override
    public TypeInformation getProducedType() {
        return deserializationSchema.getProducedType();
    }
    
}
